diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/energy/energy-model-example.cc ns-3.31/examples/energy/energy-model-example.cc
--- ns-3.30.1/examples/energy/energy-model-example.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/energy/energy-model-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -132,7 +132,7 @@
   double startTime = 0.0;       // seconds
   double distanceToRx = 100.0;  // meters
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("phyMode", "Wifi Phy mode", phyMode);
   cmd.AddValue ("Prss", "Intended primary RSS (dBm)", Prss);
   cmd.AddValue ("PpacketSize", "size of application packet sent", PpacketSize);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/energy/energy-model-with-harvesting-example.cc ns-3.31/examples/energy/energy-model-with-harvesting-example.cc
--- ns-3.30.1/examples/energy/energy-model-with-harvesting-example.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/energy/energy-model-with-harvesting-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -173,7 +173,7 @@
   // Energy Harvester variables
   double harvestingUpdateInterval = 1;  // seconds
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("phyMode", "Wifi Phy mode", phyMode);
   cmd.AddValue ("Prss", "Intended primary RSS (dBm)", Prss);
   cmd.AddValue ("PacketSize", "size of application packet sent", PacketSize);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/error-model/simple-error-model.cc ns-3.31/examples/error-model/simple-error-model.cc
--- ns-3.30.1/examples/error-model/simple-error-model.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/error-model/simple-error-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -70,7 +70,7 @@
 
   // Allow the user to override any of the defaults and the above
   // Bind()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue("errorModelType", "TypeId of the error model to use", errorModelType);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/fragmentation-ipv6.cc ns-3.31/examples/ipv6/fragmentation-ipv6.cc
--- ns-3.30.1/examples/ipv6/fragmentation-ipv6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/fragmentation-ipv6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -45,7 +45,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/fragmentation-ipv6-two-MTU.cc ns-3.31/examples/ipv6/fragmentation-ipv6-two-MTU.cc
--- ns-3.30.1/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/fragmentation-ipv6-two-MTU.cc	2020-06-27 17:38:30.000000000 -0700
@@ -47,7 +47,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/icmpv6-redirect.cc ns-3.31/examples/ipv6/icmpv6-redirect.cc
--- ns-3.30.1/examples/ipv6/icmpv6-redirect.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/icmpv6-redirect.cc	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/loose-routing-ipv6.cc ns-3.31/examples/ipv6/loose-routing-ipv6.cc
--- ns-3.30.1/examples/ipv6/loose-routing-ipv6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/loose-routing-ipv6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -53,7 +53,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/ping6.cc ns-3.31/examples/ipv6/ping6.cc
--- ns-3.30.1/examples/ipv6/ping6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/ping6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -43,7 +43,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/radvd.cc ns-3.31/examples/ipv6/radvd.cc
--- ns-3.30.1/examples/ipv6/radvd.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/radvd.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,7 +49,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/radvd-two-prefix.cc ns-3.31/examples/ipv6/radvd-two-prefix.cc
--- ns-3.30.1/examples/ipv6/radvd-two-prefix.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/radvd-two-prefix.cc	2020-06-27 17:38:30.000000000 -0700
@@ -84,7 +84,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/ipv6/wsn-ping6.cc ns-3.31/examples/ipv6/wsn-ping6.cc
--- ns-3.30.1/examples/ipv6/wsn-ping6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/ipv6/wsn-ping6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -47,7 +47,7 @@
 {
   bool verbose = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.Parse (argc, argv);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/matrix-topology/matrix-topology.cc ns-3.31/examples/matrix-topology/matrix-topology.cc
--- ns-3.30.1/examples/matrix-topology/matrix-topology.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/matrix-topology/matrix-topology.cc	2020-06-27 17:38:30.000000000 -0700
@@ -99,7 +99,7 @@
   std::string adj_mat_file_name ("examples/matrix-topology/adjacency_matrix.txt");
   std::string node_coordinates_file_name ("examples/matrix-topology/node_coordinates.txt");
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
   
   // ---------- End of Simulation Variables ----------------------------------
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/naming/object-names.cc ns-3.31/examples/naming/object-names.cc
--- ns-3.30.1/examples/naming/object-names.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/naming/object-names.cc	2020-06-27 17:38:30.000000000 -0700
@@ -21,6 +21,8 @@
 //       =================
 //              LAN
 //
+// This program demonstrates some basic use of the Object names capability
+//
 
 #include "ns3/core-module.h"
 #include "ns3/csma-module.h"
@@ -31,20 +33,21 @@
 
 NS_LOG_COMPONENT_DEFINE ("ObjectNamesExample");
 
+uint32_t bytesReceived = 0;
+
 void 
 RxEvent (std::string context, Ptr<const Packet> packet)
 {
-  NS_LOG_INFO (context << " packet " << packet);
+  std::cout << Simulator::Now ().GetSeconds () << "s " << context << " packet size " << packet->GetSize () << std::endl;
+  bytesReceived += packet->GetSize ();
 }
 
 int 
 main (int argc, char *argv[])
 {
-#if 1
-  LogComponentEnable ("ObjectNamesExample", LOG_LEVEL_INFO);
-#endif
+  bool outputValidated = true;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   NodeContainer n;
@@ -103,8 +106,23 @@
   // in this case, the "/Names" prefix is always required since the _Config_ 
   // system always expects to see a fully qualified path name.
   //
+
+  Ptr<CsmaNetDevice> csmaNetDevice = d.Get (0)->GetObject<CsmaNetDevice> ();
+  UintegerValue val;
+  csmaNetDevice->GetAttribute ("Mtu", val);
+  std::cout << "MTU on device 0 before configuration is " << val.Get () << std::endl;
+  
   Config::Set ("/Names/client/eth0/Mtu", UintegerValue (1234));
 
+  // Check the attribute again
+  csmaNetDevice->GetAttribute ("Mtu", val);
+  std::cout << "MTU on device 0 after configuration is " << val.Get () << std::endl;
+
+  if (val.Get () != 1234)
+    {
+      outputValidated = false;
+    }
+
   //
   // You can mix and match names and Attributes in calls to the Config system.
   // For example, if "eth0" is a named object, you can get to its parent through
@@ -178,6 +196,20 @@
   //
   csma.EnablePcap ("client-device.pcap", d.Get (0), false, true);
 
+  std::cout << "Running simulation..." << std::endl;
   Simulator::Run ();
   Simulator::Destroy ();
+
+  // Expected to see ARP exchange and one packet
+  // 64 bytes (minimum Ethernet frame size) x 2, plus (1024 + 8 + 20 + 18)
+  if (bytesReceived != (64 + 64 + 1070))
+    {
+      outputValidated = false;
+    }
+
+  if (outputValidated == false)
+    {
+      std::cerr << "Program internal checking failed; returning with error" << std::endl; 
+      return (1);
+    }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/realtime/realtime-udp-echo.cc ns-3.31/examples/realtime/realtime-udp-echo.cc
--- ns-3.30.1/examples/realtime/realtime-udp-echo.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/realtime/realtime-udp-echo.cc	2020-06-27 17:38:30.000000000 -0700
@@ -42,7 +42,7 @@
   // Allow the user to override any of the defaults and the above Bind() at
   // run-time, via command-line arguments
   //
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   //
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/dynamic-global-routing.cc ns-3.31/examples/routing/dynamic-global-routing.cc
--- ns-3.30.1/examples/routing/dynamic-global-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/dynamic-global-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -88,7 +88,7 @@
 
   // Allow the user to override any of the defaults and the above
   // Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   NS_LOG_INFO ("Create nodes.");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/global-injection-slash32.cc ns-3.31/examples/routing/global-injection-slash32.cc
--- ns-3.30.1/examples/routing/global-injection-slash32.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/global-injection-slash32.cc	2020-06-27 17:38:30.000000000 -0700
@@ -50,7 +50,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   Ptr<Node> nA = CreateObject<Node> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/global-routing-multi-switch-plus-router.cc ns-3.31/examples/routing/global-routing-multi-switch-plus-router.cc
--- ns-3.30.1/examples/routing/global-routing-multi-switch-plus-router.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/global-routing-multi-switch-plus-router.cc	2020-06-27 17:38:30.000000000 -0700
@@ -282,7 +282,7 @@
   // ----------------------------------------------------------------------
   // Create command line options and get them
   // ----------------------------------------------------------------------
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
 
   cmd.Usage    ("NOTE: valid --pcap arguments are: 't2,t3,b2,b3,trlan,trwan,brlan,brwan'");
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/global-routing-slash32.cc ns-3.31/examples/routing/global-routing-slash32.cc
--- ns-3.30.1/examples/routing/global-routing-slash32.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/global-routing-slash32.cc	2020-06-27 17:38:30.000000000 -0700
@@ -42,7 +42,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   Ptr<Node> nA = CreateObject<Node> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/manet-routing-compare.cc ns-3.31/examples/routing/manet-routing-compare.cc
--- ns-3.30.1/examples/routing/manet-routing-compare.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/manet-routing-compare.cc	2020-06-27 17:38:30.000000000 -0700
@@ -187,7 +187,7 @@
 std::string
 RoutingExperiment::CommandSetup (int argc, char **argv)
 {
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("CSVfileName", "The name of the CSV output file name", m_CSVfileName);
   cmd.AddValue ("traceMobility", "Enable mobility tracing", m_traceMobility);
   cmd.AddValue ("protocol", "1=OLSR;2=AODV;3=DSDV;4=DSR", m_protocol);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/mixed-global-routing.cc ns-3.31/examples/routing/mixed-global-routing.cc
--- ns-3.30.1/examples/routing/mixed-global-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/mixed-global-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -55,7 +55,7 @@
 
   // Allow the user to override any of the defaults and the above
   // Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   NS_LOG_INFO ("Create nodes.");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/ripng-simple-network.cc ns-3.31/examples/routing/ripng-simple-network.cc
--- ns-3.30.1/examples/routing/ripng-simple-network.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/ripng-simple-network.cc	2020-06-27 17:38:30.000000000 -0700
@@ -76,7 +76,7 @@
   bool showPings = false;
   std::string SplitHorizon ("PoisonReverse");
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.AddValue ("printRoutingTables", "Print routing tables at 30, 60 and 90 seconds", printRoutingTables);
   cmd.AddValue ("showPings", "Show Ping6 reception", showPings);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/rip-simple-network.cc ns-3.31/examples/routing/rip-simple-network.cc
--- ns-3.30.1/examples/routing/rip-simple-network.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/rip-simple-network.cc	2020-06-27 17:38:30.000000000 -0700
@@ -76,7 +76,7 @@
   bool showPings = false;
   std::string SplitHorizon ("PoisonReverse");
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("verbose", "turn on log components", verbose);
   cmd.AddValue ("printRoutingTables", "Print routing tables at 30, 60 and 90 seconds", printRoutingTables);
   cmd.AddValue ("showPings", "Show Ping6 reception", showPings);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/simple-alternate-routing.cc ns-3.31/examples/routing/simple-alternate-routing.cc
--- ns-3.30.1/examples/routing/simple-alternate-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/simple-alternate-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -65,7 +65,7 @@
   // The below metric, if set to 3 or higher, will cause packets between
   // n1 and n3 to take the 2-hop route through n2
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   // 
   // Additionally, we plumb this metric into the default value / command 
   // line argument system as well, for exemplary purposes.  This means 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/simple-global-routing.cc ns-3.31/examples/routing/simple-global-routing.cc
--- ns-3.30.1/examples/routing/simple-global-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/simple-global-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -68,7 +68,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   bool enableFlowMonitor = false;
   cmd.AddValue ("EnableMonitor", "Enable Flow Monitor", enableFlowMonitor);
   cmd.Parse (argc, argv);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/simple-multicast-flooding.cc ns-3.31/examples/routing/simple-multicast-flooding.cc
--- ns-3.30.1/examples/routing/simple-multicast-flooding.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/examples/routing/simple-multicast-flooding.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,207 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2013 Universita' di Firenze
+ * Copyright (c) 2019 Caliola Engineering, LLC : RFC 6621 multicast packet de-duplication
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ * Modified (2019): Jared Dulmage <jared.dulmage@caliola.com>
+ *   Demonstrates dissemination of multicast packets across a mesh
+ *   network to all nodes over multiple hops.
+ */
+
+#include "ns3/test.h"
+#include "ns3/simulator.h"
+#include "ns3/simple-channel.h"
+#include "ns3/simple-net-device.h"
+#include "ns3/socket.h"
+#include "ns3/boolean.h"
+#include "ns3/double.h"
+#include "ns3/string.h"
+#include "ns3/config.h"
+#include "ns3/data-rate.h"
+#include "ns3/uinteger.h"
+
+#include "ns3/names.h"
+#include "ns3/log.h"
+#include "ns3/node.h"
+#include "ns3/inet-socket-address.h"
+#include "ns3/random-variable-stream.h"
+
+#include "ns3/ipv4-l3-protocol.h"
+#include "ns3/ipv4-static-routing.h"
+#include "ns3/udp-socket-factory.h"
+#include "ns3/udp-socket.h"
+#include "ns3/packet-sink.h"
+
+#include "ns3/internet-stack-helper.h"
+#include "ns3/ipv4-list-routing-helper.h"
+#include "ns3/ipv4-static-routing-helper.h"
+#include "ns3/ipv4-address-helper.h"
+#include "ns3/simple-net-device-helper.h"
+#include "ns3/packet-sink-helper.h"
+#include "ns3/on-off-helper.h"
+#include "ns3/trace-helper.h"
+
+#include "ns3/traffic-control-layer.h"
+
+#include <string>
+#include <limits>
+#include <functional>
+
+using namespace ns3;
+
+/**
+ * Network topology:
+ *
+ *        /---- B ----\
+ *  A ----      |       ---- D ---- E
+ *        \---- C ----/
+ *
+ * This example demonstrates configuration of
+ * static routing to realize broadcast-like
+ * flooding of packets from node A 
+ * across the illustrated topology.
+ */
+int
+main (int argc, char *argv[])
+{
+  // multicast target
+  const std::string targetAddr = "239.192.100.1";
+  Config::SetDefault ("ns3::Ipv4L3Protocol::EnableDuplicatePacketDetection", BooleanValue (true));
+  Config::SetDefault ("ns3::Ipv4L3Protocol::DuplicateExpire", TimeValue (Seconds (10)));
+
+  // Create topology
+
+  // Create nodes
+  auto nodes = NodeContainer ();
+  nodes.Create (5);
+
+  // Name nodes
+  Names::Add ("A", nodes.Get (0));
+  Names::Add ("B", nodes.Get (1));
+  Names::Add ("C", nodes.Get (2));
+  Names::Add ("D", nodes.Get (3));
+  Names::Add ("E", nodes.Get (4));
+
+  SimpleNetDeviceHelper simplenet;
+  auto devices = simplenet.Install (nodes);
+  // name devices
+  Names::Add ("A/dev", devices.Get (0));
+  Names::Add ("B/dev", devices.Get (1));
+  Names::Add ("C/dev", devices.Get (2));
+  Names::Add ("D/dev", devices.Get (3));
+  Names::Add ("E/dev", devices.Get (4));
+
+  // setup static routes to facilitate multicast flood
+  Ipv4ListRoutingHelper listRouting;
+  Ipv4StaticRoutingHelper staticRouting;
+  listRouting.Add (staticRouting, 0);
+
+  InternetStackHelper internet;
+  internet.SetIpv6StackInstall (false);
+  internet.SetIpv4ArpJitter (true);
+  internet.SetRoutingHelper (listRouting);
+  internet.Install (nodes);
+
+  Ipv4AddressHelper ipv4address;
+  ipv4address.SetBase ("10.0.0.0", "255.255.255.0");
+  ipv4address.Assign (devices);
+
+  // add static routes for each node / device
+  for (auto diter = devices.Begin (); diter != devices.End (); ++diter)
+    {
+      Ptr<Node> node = (*diter)->GetNode ();
+
+      if (Names::FindName (node) == "A")
+        {
+          // route for host
+          // Use host routing entry according to note in Ipv4StaticRouting::RouteOutput:
+          //// Note:  Multicast routes for outbound packets are stored in the
+          //// normal unicast table.  An implication of this is that it is not
+          //// possible to source multicast datagrams on multiple interfaces.
+          //// This is a well-known property of sockets implementation on
+          //// many Unix variants.
+          //// So, we just log it and fall through to LookupStatic ()
+          auto ipv4 = node->GetObject <Ipv4> ();
+          NS_ASSERT_MSG ((bool) ipv4, "Node " << Names::FindName (node) << " does not have Ipv4 aggregate");
+          auto routing = staticRouting.GetStaticRouting (ipv4);
+          routing->AddHostRouteTo (targetAddr.c_str (), ipv4->GetInterfaceForDevice (*diter), 0);
+        }
+      else
+        {
+          // route for forwarding
+          staticRouting.AddMulticastRoute (node, Ipv4Address::GetAny (), targetAddr.c_str (), *diter, NetDeviceContainer (*diter));
+        }
+    }
+
+  // set the topology, by default fully-connected
+  auto channel = devices.Get (0)->GetChannel ();
+  auto simplechannel = channel->GetObject <SimpleChannel> ();
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("A/dev"), Names::Find <SimpleNetDevice> ("D/dev"));
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("D/dev"), Names::Find <SimpleNetDevice> ("A/dev"));
+
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("A/dev"), Names::Find <SimpleNetDevice> ("E/dev"));
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("E/dev"), Names::Find <SimpleNetDevice> ("A/dev"));
+
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("B/dev"), Names::Find <SimpleNetDevice> ("E/dev"));
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("E/dev"), Names::Find <SimpleNetDevice> ("B/dev"));
+
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("C/dev"), Names::Find <SimpleNetDevice> ("E/dev"));
+  simplechannel->BlackList (Names::Find <SimpleNetDevice> ("E/dev"), Names::Find <SimpleNetDevice> ("C/dev"));
+  // ensure some time progress between re-transmissions
+  simplechannel->SetAttribute ("Delay", TimeValue (MilliSeconds (1)));
+  
+  // sinks
+  PacketSinkHelper sinkHelper ("ns3::UdpSocketFactory", InetSocketAddress (Ipv4Address::GetAny (), 9));
+  auto sinks = sinkHelper.Install ("B");
+  sinks.Add (sinkHelper.Install ("C"));
+  sinks.Add (sinkHelper.Install ("D"));
+  sinks.Add (sinkHelper.Install ("E"));
+  sinks.Start (Seconds (1));
+
+  // source
+  OnOffHelper onoffHelper ("ns3::UdpSocketFactory", InetSocketAddress (targetAddr.c_str (), 9));
+  onoffHelper.SetAttribute ("DataRate", DataRateValue (DataRate ("8Mbps")));
+  onoffHelper.SetAttribute ("MaxBytes", UintegerValue (10 * 1024));
+  auto source = onoffHelper.Install ("A");
+  source.Start (Seconds (1.1));
+
+  // pcap traces
+  for (auto end = nodes.End (),
+           iter = nodes.Begin (); iter != end; ++iter)
+    {
+      internet.EnablePcapIpv4 ("smf-trace", (*iter)->GetId (), 1, false);
+    }
+
+  // run simulation
+  Simulator::Run ();
+  
+  std::cout << "Node A sent " << 10 * 1024 << " bytes" << std::endl;
+  for (auto end = sinks.End (),
+           iter = sinks.Begin (); iter != end; ++iter)
+    {
+      auto node = (*iter)->GetNode ();
+      auto sink = (*iter)->GetObject <PacketSink> ();
+      std::cout << "Node " << Names::FindName (node) 
+                << " received " << sink->GetTotalRx () << " bytes" << std::endl;
+    }
+
+  Simulator::Destroy ();
+
+  Names::Clear ();
+  return 0;
+}
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/simple-routing-ping6.cc ns-3.31/examples/routing/simple-routing-ping6.cc
--- ns-3.30.1/examples/routing/simple-routing-ping6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/simple-routing-ping6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -101,7 +101,7 @@
   LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
 #endif
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   StackHelper stackHelper;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/static-routing-slash32.cc ns-3.31/examples/routing/static-routing-slash32.cc
--- ns-3.30.1/examples/routing/static-routing-slash32.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/static-routing-slash32.cc	2020-06-27 17:38:30.000000000 -0700
@@ -42,7 +42,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   Ptr<Node> nA = CreateObject<Node> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/routing/wscript ns-3.31/examples/routing/wscript
--- ns-3.30.1/examples/routing/wscript	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/routing/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -50,3 +50,7 @@
     obj = bld.create_ns3_program('global-routing-multi-switch-plus-router',
                                  ['core', 'network', 'applications', 'internet', 'bridge', 'csma', 'point-to-point', 'csma', 'internet'])
     obj.source = 'global-routing-multi-switch-plus-router.cc'
+
+    obj = bld.create_ns3_program('simple-multicast-flooding',
+                                 ['core', 'network', 'applications', 'internet'])
+    obj.source = 'simple-multicast-flooding.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/socket/socket-bound-static-routing.cc ns-3.31/examples/socket/socket-bound-static-routing.cc
--- ns-3.30.1/examples/socket/socket-bound-static-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/socket/socket-bound-static-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -57,7 +57,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   Ptr<Node> nSrc = CreateObject<Node> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/socket/socket-bound-tcp-static-routing.cc ns-3.31/examples/socket/socket-bound-tcp-static-routing.cc
--- ns-3.30.1/examples/socket/socket-bound-tcp-static-routing.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/socket/socket-bound-tcp-static-routing.cc	2020-06-27 17:38:30.000000000 -0700
@@ -67,7 +67,7 @@
 
   // Allow the user to override any of the defaults and the above
   // DefaultValue::Bind ()s at run-time, via command-line arguments
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Parse (argc, argv);
 
   Ptr<Node> nSrc = CreateObject<Node> ();
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/socket/socket-options-ipv4.cc ns-3.31/examples/socket/socket-options-ipv4.cc
--- ns-3.30.1/examples/socket/socket-options-ipv4.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/socket/socket-options-ipv4.cc	2020-06-27 17:38:30.000000000 -0700
@@ -82,7 +82,7 @@
   uint32_t ipTtl = 0;
   bool ipRecvTtl = true;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("PacketSize", "Packet size in bytes", packetSize);
   cmd.AddValue ("PacketCount", "Number of packets to send", packetCount);
   cmd.AddValue ("Interval", "Interval between packets", packetInterval);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/socket/socket-options-ipv6.cc ns-3.31/examples/socket/socket-options-ipv6.cc
--- ns-3.30.1/examples/socket/socket-options-ipv6.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/socket/socket-options-ipv6.cc	2020-06-27 17:38:30.000000000 -0700
@@ -82,7 +82,7 @@
   uint32_t ipv6Hoplimit = 0;
   bool ipv6RecvHoplimit = true;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("PacketSize", "Packet size in bytes", packetSize);
   cmd.AddValue ("PacketCount", "Number of packets to send", packetCount);
   cmd.AddValue ("Interval", "Interval between packets", packetInterval);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/examples/stats/wifi-example-sim.cc ns-3.31/examples/stats/wifi-example-sim.cc
--- ns-3.30.1/examples/stats/wifi-example-sim.cc	2019-08-12 16:30:33.000000000 -0700
+++ ns-3.31/examples/stats/wifi-example-sim.cc	2020-06-27 17:38:30.000000000 -0700
@@ -76,7 +76,7 @@
   }
 
   // Set up command line parameters used to control the experiment.
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("distance", "Distance apart to place nodes (in meters).",
                 distance);
   cmd.AddValue ("format", "Format to use for data output.",
